<template>
  <v-dialog
    v-model="changePassword"
    @keydown.esc="handleClose"
    @click:outside="handleClose"
    max-width="600px"
  >
    <v-card>
      <v-card-title class="primary">
        <span class="headline white--text">
          {{ $vuetify.lang.t('$vuetify.changePassword.title') }}
        </span>
      </v-card-title>
      <v-card-text>
        <v-form ref="form" v-model="valid">
          <v-container>
            <v-row>
              <v-col cols="12" sm="12" md="12">
                <v-text-field
                  autofocus
                  v-model="objectPassword.oldPass"
                  :append-icon="show1 ? 'mdi-eye' : 'mdi-eye-off'"
                  :type="show1 ? 'text' : 'password'"
                  prepend-icon="mdi-lock"
                  required
                  :label="$vuetify.lang.t('$vuetify.changePassword.fields.oldPass')"
                  :rules="[rules.required]"
                  @click:append="show1 = !show1"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="12">
                <v-text-field
                  v-model="objectPassword.newPass"
                  :label="$vuetify.lang.t('$vuetify.changePassword.fields.newPass')"
                  :append-icon="show2 ? 'mdi-eye' : 'mdi-eye-off'"
                  :type="show2 ? 'text' : 'password'"
                  prepend-icon="mdi-lock"
                  required
                  :rules="[rules.required]"
                  @click:append="show2 = !show2"
                  :messages="['A senha deve ter pelo menos 6 caracteres.']"
                ></v-text-field>
              </v-col>
              <v-col cols="12" sm="12" md="12">
                <v-text-field
                  v-model="objectPassword.newPassConfirmation"
                  :label="$vuetify.lang.t('$vuetify.changePassword.fields.confirmNewPass')"
                  :append-icon="show3 ? 'mdi-eye' : 'mdi-eye-off'"
                  :type="show3 ? 'text' : 'password'"
                  prepend-icon="mdi-lock"
                  required
                  :rules="[rules.required]"
                  @click:append="show3 = !show3"
                  :messages="['A senha deve ter pelo menos 6 caracteres.']"
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small class="pl-4">
          {{ $vuetify.lang.t('$vuetify.changePassword.warning') }}
        </small>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="light" text @click="handleClose">
          {{ $vuetify.lang.t('$vuetify.actions.close') }}
        </v-btn>
        <v-btn color="light" text :disabled="!valid" @click="handleUpdate">
          {{ $vuetify.lang.t('$vuetify.actions.confirm') }}
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
import { mapMutations, mapState } from 'vuex'
import User from '../../services/user.js'

export default {
  name: 'ChangePassword',
  components: {},
  data: () => ({
    show1: false,
    show2: false,
    show3: false,
    objectPassword: {
      oldPass: '',
      newPass: '',
      newPassConfirmation: '',
    },
    valid: false,
    rules: {
      required: (v) => !!v || 'Campo exigido.',
    },
  }),
  computed: {
    ...mapState('user', ['changePassword']),
  },
  methods: {
    ...mapMutations('user', ['UPDATE_USER_CHANGE_PASSWORD', 'UPDATE_BASE_SNACKBAR']),
    handleClose() {
      this.$refs.form.reset()
      this.UPDATE_USER_CHANGE_PASSWORD(false)
    },
    async handleUpdate() {
      try {
        console.log(this.objectPassword.newPass, "teste")
        if ((this.objectPassword.newPass === this.objectPassword.newPassConfirmation) 
        && this.objectPassword.newPass.length >= 6
        && this.objectPassword.newPassConfirmation.length >= 6 ) {
          console.log('fodase')
          let ret = await User.updatePassword({
            currentPassword: this.objectPassword.oldPass,
            newPassword: this.objectPassword.newPass,
          })
          console.log('ret', ret)
          if (ret.success) {
            this.UPDATE_BASE_SNACKBAR({
              open: true,
              text: this.$vuetify.lang.t('$vuetify.changePassword.success'),
            })
            this.handleClose()
          }
        } else {
          this.UPDATE_BASE_SNACKBAR({
            open: true,
            text: this.$vuetify.lang.t('$vuetify.changePassword.errorSamePass'),
          })
        }
      } catch (e) {
        this.UPDATE_BASE_SNACKBAR({
          open: true,
          text: this.$vuetify.lang.t('$vuetify.changePassword.error'),
        })
        this.handleClose()
      }
    },
  },
}
</script>

<style scoped></style>
